<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Test_4</title>
    <script type="text/javascript" src="lib/three.js"></script>


    <style>
        canvas {
            position: absolute;
            top: 0;
            left: 0;
            z-index: -100;
        }

        #canvas {
            color: #999999;
            position: absolute;
            top: 0;
            left: 0;
            z-index: -100;
        }


    </style>
</head>
<body>

<div id="canvas">


</div>


<script>


    var camera, scene, renderer;
    var surface, surfaceMaterial, surfaceMesh;
    var sphere, sphereGeometry, sphereMaterial;
    var sphere2, sphereGeometry2, sphereMaterial2;


    var spotLight;

    var object, container;


    init();
    animate();


    function init() {


        THREE.IcosahedronGeometry = function (radius, detail) {
            var t = (1 + Math.sqrt(5)) / 2;
            var vertices = [-1, t, 0, 1, t, 0, -1, -t, 0, 1, -t, 0,
                0, -1, t, 0, 1, t, 0, -1, -t, 0, 1, -t,
                t, 0, -1, t, 0, 1, -t, 0, -1, -t, 0, 1
            ];
            var indices = [
                0, 11, 5, 0, 5, 1, 0, 1, 7, 0, 7, 10, 0, 10, 11,
                1, 5, 9, 5, 11, 4, 11, 10, 2, 10, 7, 6, 7, 1, 8,
                3, 9, 4, 3, 4, 2, 3, 2, 6, 3, 6, 8, 3, 8, 9,
                4, 9, 5, 2, 4, 11, 6, 2, 10, 8, 6, 7, 9, 8, 1
            ];
            THREE.PolyhedronGeometry.call(this, vertices, indices, radius, detail);
            this.type = 'IcosahedronGeometry';
            this.parameters = {
                radius: radius,
                detail: detail
            };
        };

        THREE.IcosahedronGeometry.prototype = Object.create(THREE.PolyhedronGeometry.prototype);
        THREE.IcosahedronGeometry.prototype.constructor = THREE.IcosahedronGeometry;

// Scene
        scene = new THREE.Scene();
        camera = new THREE.PerspectiveCamera(75, window.innerWidth / window.innerHeight, 0.1, 1000);

        container = document.getElementById('canvas');
        //document.body.appendChild(container);


        renderer = new THREE.WebGLRenderer({
            antialias: 1, alpha: true
        });

        renderer.setClearColor(0x000000, 0); // the default

        renderer.setSize(window.innerWidth, window.innerHeight);

        container.appendChild(renderer.domElement);

        renderer.shadowMap.enabled = true;
        renderer.shadowMap.type = THREE.PCFSoftShadowMap;


// Create vertex points
        var mesh = new THREE.IcosahedronGeometry(10, 1); // radius, detail
        var vertices = mesh.vertices;
        var positions = new Float32Array(vertices.length * 3);
        for (var i = 0, l = vertices.length; i < l; i++) {
            vertices[i].toArray(positions, i * 3);
        }

        var geometry = new THREE.BufferGeometry();
        geometry.addAttribute('position', new THREE.BufferAttribute(positions, 3));

        var material = new THREE.PointsMaterial({
            size: 0.4,
            vertexColors: THREE.VertexColors,
            color: 0x252525
        });
        var points = new THREE.Points(geometry, material);

        object = new THREE.Object3D();
        points.castShadow = true;
        object.add(points);


        object.add(new THREE.Mesh(
            mesh,
            new THREE.MeshPhongMaterial({
                color: 0x616161,
                emissive: 0xa1a1a1,
                wireframe: true
            })
        ));


        // object.castShadow = true;
        scene.add(object);


        spotLight = new THREE.SpotLight(0xffffff, 0.7);
        spotLight.angle = Math.PI / 3.5;
        spotLight.penumbra = 0.4;
        spotLight.position.set(0, 35, -5);
        spotLight.castShadow = true;
        spotLight.shadow.camera.near = 1;
        spotLight.shadow.camera.far = 80;
        spotLight.shadow.mapSize.width = 1024;
        spotLight.shadow.mapSize.height = 1024;
        scene.add(spotLight);


        sphereGeometry = new THREE.SphereGeometry(3, 3, 30);
        sphereMaterial = new THREE.MeshPhongMaterial({
            shininess: 150,
            specular: 0xffffff,
            flatShading : true
        });
        sphere = new THREE.Mesh(sphereGeometry, sphereMaterial);
        sphere.position.set(0, 3, -3);
        sphere.castShadow = true;
        scene.add(sphere);

        sphereGeometry2 = new THREE.SphereGeometry(50, 40, 30);
        sphereMaterial2 = new THREE.MeshPhongMaterial({
            shininess: 100,
            flatShading : true,
            side: THREE.DoubleSide

        });
        sphere2 = new THREE.Mesh(sphereGeometry2, sphereMaterial2);
        sphere2.position.set(-10, 22, -3);
        sphere2.castShadow = true;
        sphere2.receiveShadow = true;
        scene.add(sphere2);


        camera.position.z = 30;
        camera.position.y = 10;
        camera.lookAt(scene.position);


    }

    function animate() {

        var t = (Date.now() / 1000);

        requestAnimationFrame(animate);
        object.rotation.x += 0.01;
        object.rotation.y += 0.01;
        sphere.rotation.y += 0.01;
        sphere.rotation.x += 0.01;
        sphere2.rotation.y += 0.001;
        sphere2.rotation.z += 0.001;

        renderer.render(scene, camera);


    }

</script>


</body>
</html>